Index: trunk/AddOn/TAcq/branap.cc
===================================================================
--- trunk/AddOn/TAcq/branap.cc	(revision 4014)
+++ trunk/AddOn/TAcq/branap.cc	(revision 4015)
@@ -29,4 +29,5 @@
   prtlevel_=0;
   prtmodulo_=50000;
+  prtmodulo2_=10;
 
   nmean_=nmean;
@@ -83,5 +84,5 @@
     }
     else if (strcmp(arg[ka],"-tmint")==0) {
-      timeinterval_=atoi(arg[ka+1]);
+      timeinterval_=atof(arg[ka+1]);
       fgtimeinterval_=true;  ka+=2;
     }
@@ -102,5 +103,5 @@
     }
     else if (strcmp(arg[ka],"-prt")==0) {
-      sscanf(arg[ka+1],"%d,%ld",&prtlevel_,&prtmodulo_);
+      sscanf(arg[ka+1],"%d,%ld,%ld",&prtlevel_,&prtmodulo_,&prtmodulo2_);
       ka+=2;
     }
@@ -211,7 +212,7 @@
   cout << " --- BRAnaParam : Reading/Processing BAORadio FITS files parameters " << endl;
   cout << " Usage:  prgname [-act ACT] [-out OutPath] [-fitsout] \n" 
-       << "                 [-nmean NMean] [-zones NZones,nPaqinZone] \n" 
+       << "                 [-nmean NMean] [-tmint dtime] [-zones NZones,nPaqinZone] \n" 
        << "                 [-nbloc NBloc] [-freq NumFreqMin,NumFreqMax,NBinFreq] \n" 
-       << "                 [-prt lev,modulo] [-nvcal n] [-nthr n] [-nosfc]\n"
+       << "                 [-prt lev,modulo,mod2] [-nvcal n] [-nthr n] [-nosfc]\n"
        << "                 [-singlechan] [-twochan] [-fftdata] [-rawdata] \n"
        << "                 [-freqfilter medhw] [-gain filename] [-varcut min,max] [-nband nband,first,last] \n"
@@ -236,5 +237,5 @@
        << " -zones NZones,NbPaqinZone : Number of Zones and number of paquets in one zone (RAcqMemZoneMgr) \n" 
        << " -freq NumFreqMin,NumFreqMax,NBinFreq : Frequency zone and number of bins \n" 
-       << " -prt lev,modulo : Print level (0,1,2...) and print counter modulo (10000, 50000 ...) \n" 
+       << " -prt lev,modulo,mod2 : Print level (0,1,2...), counter modulo (10000,50000...), mod2 (10,50...) for filenums \n" 
        << " -nvcal n : number of BRVisibilityCalculator objects running in parallel in BRVisCalcGroup  (default=1) \n" 
        << " -nthr n : number of threads for parallel execution in BRVisibilityCalculator (default=1) \n" 
@@ -315,5 +316,5 @@
        << " MaxNbFile=" << nbmax_specwfiles_ << endl; 
   cout << " PaqSize=" << paqsize_ << "  -  NZones=" << nzones_ << " NPaqZone=" << npaqinzone_ 
-       << " PrtLevel=" << prtlevel_ << " PrtCntModulo=" <<  prtmodulo_ << endl;
+       << " PrtLevel=" << prtlevel_ << " PrtCntModulo=" <<  prtmodulo_ << "," << prtmodulo2_ << endl;
   cout << " AcqDataMode: " << ((fgdatafft_)?" Data_FFT " : " Data_Raw " ) 
        << ((fgsinglechannel_)?" SingleChannel " : " TwoChannels " ) << endl;
Index: trunk/AddOn/TAcq/branap.h
===================================================================
--- trunk/AddOn/TAcq/branap.h	(revision 4014)
+++ trunk/AddOn/TAcq/branap.h	(revision 4015)
@@ -45,5 +45,5 @@
   bool fgforcesingleortwochan_; // true force par la ligne de commande
   int prtlevel_;
-  long int prtmodulo_; 
+  long int prtmodulo_, prtmodulo2_; 
 
   uint_4 nmean_;
Index: trunk/AddOn/TAcq/brviscalc.cc
===================================================================
--- trunk/AddOn/TAcq/brviscalc.cc	(revision 4014)
+++ trunk/AddOn/TAcq/brviscalc.cc	(revision 4015)
@@ -38,4 +38,5 @@
 
   npaqcumul_=0;
+  threshold_tt_=0;
   moyfc_=moytt_=0.;
   first_fc_=first_tt_=0;
@@ -333,6 +334,7 @@
       if ( CheckInterval4VisMtxSave() ) {
 	if ((prtlev_>0)&&(numfile_%prtmodulo_==0)) {
-	  cout << numfile_ << "-BRVisCalc[" << calcid_ << "/" << nbcalc_ << "]::run() NPaqProc="
-	       << totnbpaq_ << " TotMegaFLOP=" << (uint_8)TotNbMegaFLOP() << " -> VisibMtx FileNum=" << numfile_ << endl;
+	  cout << numfile_ << "-BRVisCalc[" << calcid_ << "/" << nbcalc_ << "]::run() NPaqProc=" << totnbpaq_ 
+	       << " TTSec=" << getCurTimeTagSeconds() << " TotMegaFLOP=" << (uint_8)TotNbMegaFLOP() 
+	       << " VisibMtx_FileNum=" << numfile_ << endl;
 	}
 	SaveVisibilityMatrix();
@@ -353,4 +355,7 @@
 	      ttfirst_[fib]=vpaq_[fib].TimeTag();
 	    }
+	    threshold_tt_=vpaq_[0].TimeTag();
+	    first_fc_=curfc_[0];
+	    first_tt_=vpaq_[0].TimeTag();
 	  }
 	  totprocnpaq_++;
@@ -398,5 +403,10 @@
 int BRVisibilityCalculator::Process()
 {
-  if (totnbpaq_==0) UpdateChanIds();  // Appele ici pour etre sur que le thread de remplissage a mis l'info a jour.
+  if (totnbpaq_==0) {    // qques initialisations a partir du premier paquet 
+    UpdateChanIds();  // Appele ici pour etre sur que le thread de remplissage a mis l'info a jour.
+    threshold_tt_=vpaq_[0].TimeTag();
+    first_fc_=curfc_[0];
+    first_tt_= vpaq_[0].TimeTag();
+  }
   if (fgdataraw_) {  // Donnees firmware RAW apres TF soft 
     for(size_t fib=0; fib<(size_t)memgr_.NbFibres(); fib++) {
@@ -414,6 +424,7 @@
   if ( CheckInterval4VisMtxSave() ) {
     if ((prtlev_>0)&&(numfile_%prtmodulo_==0)) {
-      cout << numfile_ << "-BRVisCalc[" << calcid_ << "/" << nbcalc_ << "]::Process() NPaqProc="
-	   << totnbpaq_ << " TotMegaFLOP=" << (uint_8)TotNbMegaFLOP() << " -> VisibMtx FileNum= " << numfile_ << endl;
+      cout << numfile_ << "-BRVisCalc[" << calcid_ << "/" << nbcalc_ << "]::Process() NPaqProc="<< totnbpaq_ 
+	   << " TTSec=" << getCurTimeTagSeconds() << " TotMegaFLOP=" << (uint_8)TotNbMegaFLOP() 
+	   << " VisibMtx_FileNum=" << numfile_ << endl;
     }
     SaveVisibilityMatrix();
@@ -482,4 +493,5 @@
   vismtx_ = complex<r_4>((r_4)0.,(r_4)0.);
   npaqcumul_=0;
+  threshold_tt_=vpaq_[0].TimeTag();
   moyfc_=moytt_=0.;
   first_fc_=curfc_[0];
@@ -495,5 +507,5 @@
 {
   string ikey,ikdesc;
-  ikey="DATEOBS";  ikdesc=" Date/Time corresponding to TimeTagFirst";
+  ikey="DATEOBS";  ikdesc=" Date,Time corresponding to TimeTagFirst";
   vismtx_.Info().SetS(ikey,first_tmstamp_.ToString());
   vismtx_.Info().SetComment(ikey,ikdesc);
@@ -518,4 +530,8 @@
   ikey="NPAQSUM";  ikdesc="Number of paquets summed";
   vismtx_.Info().SetI(ikey,npaqcumul_);
+  vismtx_.Info().SetComment(ikey,ikdesc);
+  ikey="DELTIME";  ikdesc="visib cumul time (seconds)";
+  vismtx_.Info().SetD(ikey,(vpaq_[0].TimeTag()-first_tt_)/1.25e8);
+  vismtx_.Info().SetComment(ikey,ikdesc);
 }
 
Index: trunk/AddOn/TAcq/brviscalc.h
===================================================================
--- trunk/AddOn/TAcq/brviscalc.h	(revision 4014)
+++ trunk/AddOn/TAcq/brviscalc.h	(revision 4015)
@@ -72,5 +72,5 @@
   // Pour passer en mode intervalle en temps pour sauvegarde matrices visibilites - intervalle de temps en secondes 
   inline void SetTimeIntervalMode(double dtime=1.)
-    { fgnpaq_time=false; dtimemean_=(dtime>1e-6)?dtime:1.; }
+    { fgnpaq_time=false; dtimemean_=(dtime>1e-6)?dtime:1.; dtimem_ttops_=(uint_8)(dtimemean_*1.25e8); }
 
   // Methode d'execution standard du thread (on redefinit la methode de BRBaseProcessor)
@@ -103,5 +103,5 @@
       return ((npaqcumul_>=nmean_)?true:false); 
     else {
-      return (((vpaq_[0].TimeTag()-first_tt_)/1.25e8>=dtimemean_)?true:false);
+      return (((vpaq_[0].TimeTag()-threshold_tt_)>=dtimem_ttops_)?true:false);
     }
   }
@@ -117,4 +117,6 @@
   uint_4 nmean_;  // Nombre de spectres pour le calcul des moyennes 
   double dtimemean_;  // Intervalle en temps pour le calcul des moyennes - exprimes en secondes 
+  uint_8 dtimem_ttops_;  // Intervalle en temps pour le calcul des moyennes - en impulsions TimeTag (125 MHz) 
+  uint_8 threshold_tt_;  // Valeurs seuil TimeTag pour chaque matrice de visibilite - muliple de dtimem_ttops_
   bool fgnpaq_time;  // true -> utilisation nmean_ comme nb de paquet/spectre, false -> dtimemean_
 
Index: trunk/AddOn/TAcq/vismfib.cc
===================================================================
--- trunk/AddOn/TAcq/vismfib.cc	(revision 4014)
+++ trunk/AddOn/TAcq/vismfib.cc	(revision 4015)
@@ -77,4 +77,5 @@
     if (par.fgfitsout_) procg.SetFitsOutput();
     if (par.fgtimeinterval_)  procg.SetTimeIntervalMode(par.timeinterval_);
+    procg.SetPrintLevel(par.prtlevel_,par.prtmodulo2_);
     BRFFTCalculator procfft(mmgr, par.fgsinglechannel_);
 