Index: trunk/SophyaLib/BaseTools/smakefile
===================================================================
--- trunk/SophyaLib/BaseTools/smakefile	(revision 3879)
+++ trunk/SophyaLib/BaseTools/smakefile	(revision 4019)
@@ -4,59 +4,58 @@
  
 clean:
-	 rm -f $(SOPHYAOBJP)datatype.o $(SOPHYAOBJP)dvlist.o $(SOPHYAOBJP)fiondblock.o $(SOPHYAOBJP)mutyv.o $(SOPHYAOBJP)ndatablock.o $(SOPHYAOBJP)pexceptions.o $(SOPHYAOBJP)ppersist.o $(SOPHYAOBJP)ppfbinstream.o $(SOPHYAOBJP)ppftpointerio.o $(SOPHYAOBJP)randfmt.o $(SOPHYAOBJP)randinterf.o $(SOPHYAOBJP)randr48.o $(SOPHYAOBJP)rawstream.o $(SOPHYAOBJP)sophyainit.o $(SOPHYAOBJP)stsrand.o $(SOPHYAOBJP)timestamp.o $(SOPHYAOBJP)dSFMT.o $(SOPHYAOBJP)gnumd5.o
+	 rm -f $(SOPHYAOBJP)datatype.o $(SOPHYAOBJP)dvlist.o $(SOPHYAOBJP)fiondblock.o $(SOPHYAOBJP)mutyv.o $(SOPHYAOBJP)ndatablock.o $(SOPHYAOBJP)pexceptions.o $(SOPHYAOBJP)ppersist.o $(SOPHYAOBJP)ppfbinstream.o $(SOPHYAOBJP)ppftpointerio.o $(SOPHYAOBJP)randtmt64.o $(SOPHYAOBJP)randtmt32.o $(SOPHYAOBJP)randfmt.o $(SOPHYAOBJP)randinterf.o $(SOPHYAOBJP)randr48.o $(SOPHYAOBJP)rawstream.o $(SOPHYAOBJP)sophyainit.o $(SOPHYAOBJP)stsrand.o $(SOPHYAOBJP)timestamp.o $(SOPHYAOBJP)dSFMT.o $(SOPHYAOBJP)gnumd5.o $(SOPHYAOBJP)tinymt32.o $(SOPHYAOBJP)tinymt64.o
 	rm -f $(SOPHYALIBP)libBaseTools.a
  
-$(SOPHYALIBP)libBaseTools.a : $(SOPHYAOBJP)datatype.o $(SOPHYAOBJP)dSFMT.o $(SOPHYAOBJP)dvlist.o $(SOPHYAOBJP)fiondblock.o $(SOPHYAOBJP)gnumd5.o $(SOPHYAOBJP)mutyv.o $(SOPHYAOBJP)ndatablock.o $(SOPHYAOBJP)pexceptions.o $(SOPHYAOBJP)ppersist.o $(SOPHYAOBJP)ppfbinstream.o $(SOPHYAOBJP)ppftpointerio.o $(SOPHYAOBJP)randfmt.o $(SOPHYAOBJP)randinterf.o $(SOPHYAOBJP)randr48.o $(SOPHYAOBJP)rawstream.o $(SOPHYAOBJP)sophyainit.o $(SOPHYAOBJP)stsrand.o $(SOPHYAOBJP)timestamp.o
+$(SOPHYALIBP)libBaseTools.a : $(SOPHYAOBJP)datatype.o $(SOPHYAOBJP)dSFMT.o $(SOPHYAOBJP)dvlist.o $(SOPHYAOBJP)fiondblock.o $(SOPHYAOBJP)gnumd5.o $(SOPHYAOBJP)mutyv.o $(SOPHYAOBJP)ndatablock.o $(SOPHYAOBJP)pexceptions.o $(SOPHYAOBJP)ppersist.o $(SOPHYAOBJP)ppfbinstream.o $(SOPHYAOBJP)ppftpointerio.o $(SOPHYAOBJP)randtmt64.o $(SOPHYAOBJP)randtmt32.o $(SOPHYAOBJP)randfmt.o $(SOPHYAOBJP)randinterf.o $(SOPHYAOBJP)randr48.o $(SOPHYAOBJP)rawstream.o $(SOPHYAOBJP)sophyainit.o $(SOPHYAOBJP)stsrand.o $(SOPHYAOBJP)timestamp.o $(SOPHYAOBJP)tinymt32.o $(SOPHYAOBJP)tinymt64.o
 	$(AR) $(ARFLAGS) $@ $? 
 	touch $(SOPHYAINCP)/SophyaConfInfo/libsophya.objlist
  
 $(SOPHYAOBJP)datatype.o: datatype.cc datatype.h \
-  $(SOPHYAINCP)machdefs.h
+ $(SOPHYAINCP)machdefs.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  datatype.cc
  
-$(SOPHYAOBJP)dvlist.o: dvlist.cc \
-  $(SOPHYAINCP)machdefs.h \
-  dvlist.h objfio.h anydataobj.h ppersist.h pexceptions.h gnumd5.h \
-  ppfbinstream.h rawstream.h ppfnametag.h mutyv.h timestamp.h \
-  $(SOPHYAINCP)strutil.h
+$(SOPHYAOBJP)dvlist.o: dvlist.cc $(SOPHYAINCP)machdefs.h \
+ dvlist.h objfio.h anydataobj.h ppersist.h pexceptions.h gnumd5.h \
+ ppfbinstream.h rawstream.h ppfnametag.h mutyv.h timestamp.h \
+ $(SOPHYAINCP)strutil.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  dvlist.cc
  
 $(SOPHYAOBJP)fiondblock.o: fiondblock.cc sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  pexceptions.h datatype.h fiondblock.h ppersist.h gnumd5.h \
-  ppfbinstream.h rawstream.h ppfnametag.h ndatablock.h anydataobj.h
+ $(SOPHYAINCP)machdefs.h pexceptions.h datatype.h \
+ fiondblock.h ppersist.h gnumd5.h ppfbinstream.h rawstream.h ppfnametag.h \
+ ndatablock.h anydataobj.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  fiondblock.cc
  
 $(SOPHYAOBJP)mutyv.o: mutyv.cc sopnamsp.h mutyv.h \
-  $(SOPHYAINCP)machdefs.h \
-  timestamp.h objfio.h anydataobj.h ppersist.h pexceptions.h gnumd5.h \
-  ppfbinstream.h rawstream.h ppfnametag.h
+ $(SOPHYAINCP)machdefs.h timestamp.h objfio.h \
+ anydataobj.h ppersist.h pexceptions.h gnumd5.h ppfbinstream.h \
+ rawstream.h ppfnametag.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  mutyv.cc
  
 $(SOPHYAOBJP)ndatablock.o: ndatablock.cc sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  pexceptions.h ndatablock.h anydataobj.h thsafeop.h
+ $(SOPHYAINCP)machdefs.h pexceptions.h \
+ ndatablock.h anydataobj.h thsafeop.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ndatablock.cc
  
 $(SOPHYAOBJP)pexceptions.o: pexceptions.cc sopnamsp.h pexceptions.h \
-  $(SOPHYAINCP)machdefs.h
+ $(SOPHYAINCP)machdefs.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  pexceptions.cc
  
 $(SOPHYAOBJP)ppersist.o: ppersist.cc sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  pexceptions.h ppersist.h gnumd5.h ppfbinstream.h rawstream.h \
-  ppfnametag.h anydataobj.h
+ $(SOPHYAINCP)machdefs.h pexceptions.h ppersist.h \
+ gnumd5.h ppfbinstream.h rawstream.h ppfnametag.h anydataobj.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ppersist.cc
  
 $(SOPHYAOBJP)ppfbinstream.o: ppfbinstream.cc sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  ppfbinstream.h rawstream.h pexceptions.h
+ $(SOPHYAINCP)machdefs.h ppfbinstream.h \
+ rawstream.h pexceptions.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ppfbinstream.cc
  
 $(SOPHYAOBJP)ppftpointerio.o: ppftpointerio.cc \
-  $(SOPHYAINCP)machdefs.h \
-  ppftpointerio.h ppersist.h pexceptions.h gnumd5.h ppfbinstream.h \
-  rawstream.h ppfnametag.h
+ $(SOPHYAINCP)machdefs.h ppftpointerio.h \
+ ppersist.h pexceptions.h gnumd5.h ppfbinstream.h rawstream.h \
+ ppfnametag.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ppftpointerio.cc
+ 
  
 $(SOPHYAOBJP)randfmt.o: randfmt.cc randfmt.h \
@@ -66,40 +65,48 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  randfmt.cc
  
+$(SOPHYAOBJP)randtmt32.o: randtmt32.cc randtmt32.h \
+  $(SOPHYAINCP)machdefs.h \
+  objfio.h anydataobj.h ppersist.h pexceptions.h gnumd5.h ppfbinstream.h \
+  rawstream.h ppfnametag.h randinterf.h tinymt32.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  randtmt32.cc
+ 
+$(SOPHYAOBJP)randtmt64.o: randtmt64.cc randtmt64.h \
+  $(SOPHYAINCP)machdefs.h \
+  objfio.h anydataobj.h ppersist.h pexceptions.h gnumd5.h ppfbinstream.h \
+  rawstream.h ppfnametag.h randinterf.h tinymt64.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  randtmt64.cc
+ 
 $(SOPHYAOBJP)randinterf.o: randinterf.cc sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  pexceptions.h randinterf.h anydataobj.h
+ $(SOPHYAINCP)machdefs.h pexceptions.h \
+ randinterf.h anydataobj.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  randinterf.cc
  
-$(SOPHYAOBJP)randr48.o: randr48.cc \
-  $(SOPHYAINCP)machdefs.h \
-  thsafeop.h pexceptions.h fiondblock.h ppersist.h gnumd5.h \
-  ppfbinstream.h rawstream.h ppfnametag.h ndatablock.h anydataobj.h \
-  randr48.h objfio.h randinterf.h
+$(SOPHYAOBJP)randr48.o: randr48.cc $(SOPHYAINCP)machdefs.h \
+ thsafeop.h pexceptions.h fiondblock.h ppersist.h gnumd5.h ppfbinstream.h \
+ rawstream.h ppfnametag.h ndatablock.h anydataobj.h randr48.h objfio.h \
+ randinterf.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  randr48.cc
  
 $(SOPHYAOBJP)rawstream.o: rawstream.cc sopnamsp.h rawstream.h \
-  $(SOPHYAINCP)machdefs.h \
-  pexceptions.h
+ $(SOPHYAINCP)machdefs.h pexceptions.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  rawstream.cc
  
 $(SOPHYAOBJP)sophyainit.o: sophyainit.cc sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  sophyainit.h pexceptions.h ppersist.h gnumd5.h ppfbinstream.h \
-  rawstream.h ppfnametag.h fiondblock.h ndatablock.h anydataobj.h \
-  dvlist.h objfio.h mutyv.h timestamp.h randr48.h randinterf.h randfmt.h \
-  fiosegdb.h segdatablock.h thsafeop.h ppftpointerio.h ppfwrapstlv.h \
-  sversion.h
+ $(SOPHYAINCP)machdefs.h sophyainit.h \
+ pexceptions.h ppersist.h gnumd5.h ppfbinstream.h rawstream.h \
+ ppfnametag.h fiondblock.h ndatablock.h anydataobj.h dvlist.h objfio.h \
+ mutyv.h timestamp.h randr48.h randinterf.h randfmt.h randtmt32.h randtmt64.h fiosegdb.h \
+ segdatablock.h thsafeop.h ppftpointerio.h ppfwrapstlv.h sversion.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sophyainit.cc
  
 $(SOPHYAOBJP)stsrand.o: stsrand.cc stsrand.h \
-  $(SOPHYAINCP)machdefs.h \
-  objfio.h anydataobj.h ppersist.h pexceptions.h gnumd5.h ppfbinstream.h \
-  rawstream.h ppfnametag.h ndatablock.h thsafeop.h fiondblock.h
+ $(SOPHYAINCP)machdefs.h objfio.h anydataobj.h \
+ ppersist.h pexceptions.h gnumd5.h ppfbinstream.h rawstream.h \
+ ppfnametag.h ndatablock.h thsafeop.h fiondblock.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  stsrand.cc
  
-$(SOPHYAOBJP)timestamp.o: timestamp.cc \
-  $(SOPHYAINCP)machdefs.h \
-  timestamp.h objfio.h anydataobj.h ppersist.h pexceptions.h gnumd5.h \
-  ppfbinstream.h rawstream.h ppfnametag.h
+$(SOPHYAOBJP)timestamp.o: timestamp.cc $(SOPHYAINCP)machdefs.h \
+ timestamp.h objfio.h anydataobj.h ppersist.h pexceptions.h gnumd5.h \
+ ppfbinstream.h rawstream.h ppfnametag.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  timestamp.cc
  
@@ -107,7 +114,12 @@
 	$(CCOMPILE) -o $@  dSFMT.c
  
-$(SOPHYAOBJP)gnumd5.o: gnumd5.c \
-  $(SOPHYAINCP)machdefs.h \
-  bithelp.h gnumd5.h
+$(SOPHYAOBJP)gnumd5.o: gnumd5.c $(SOPHYAINCP)machdefs.h \
+ bithelp.h gnumd5.h
 	$(CCOMPILE) -o $@  gnumd5.c
  
+$(SOPHYAOBJP)tinymt32.o: tinymt32.c tinymt32.h
+	$(CCOMPILE) -o $@  tinymt32.c
+ 
+$(SOPHYAOBJP)tinymt64.o: tinymt64.c tinymt64.h
+	$(CCOMPILE) -o $@  tinymt64.c
+ 